﻿init python:
    def load_map(tilemap):
        map = []
        f = open(renpy.loader.transfn(tilemap),"r")
        for line in f:
            line = line.strip()
            divided = line.split(",")
            listed = [[x, []] for x in divided]
            map.append(listed)
        f.close()
        return map
    def load_tiles(img, size):
        tiles = []
        for i in range(8):
            for ii in range(8):
                tiles.append(Crop((ii*size,i*size,size,size), img))
        return tiles

    class tile:
        def __init__(self, image, type):
            self.image = image
            self.type = type

    class level_class:
        def __init__(self, name, size, map, objects, player, entrances, exits):
            self.name = name
            self.size = size
            self.set = load_tiles(map[0], size)
            self.map = load_map(map[1])
            self.objects = objects
            self.player = player
            self.entrances = entrances
            self.exits = exits
            self.collisions = []
            for i in range(-1, 24):
                self.collisions.append(str(i))
        def enter(self, entrance):
            self.player.x = self.entrances[entrance][0]
            self.player.y = self.entrances[entrance][1]
        def show_player(self):
            self.player.alpha = 1
        def move(self, direction):
            self.player.direction = direction
            self.player.busy = 4
            self.player.stat = "walk"
            x = self.player.x
            y = self.player.y
            if direction == "up":
                if not self.map[y - 1][x][0] in self.collisions:
                    self.player.y -= 1
            elif direction == "left":
                if not self.map[y][x -1][0] in self.collisions:
                    self.player.x += -1
            elif direction == "down":
                if not self.map[y + 1][x][0] in self.collisions:
                    self.player.y += 1
            elif direction == "right":
                if not self.map[y][x + 1][0] in self.collisions:
                    self.player.x += 1
            x = self.player.x
            y = self.player.y
            for i in self.exits:
                if i[0] == x and i[1] == y:
                    g = eval(i[2])
                    self.player.alpha = 0
                    self.player.x, self.player.y = g.entrances[i[3]]
                    Show("level", g = g, transition = dissolve)()
    class actor:
        def __init__(self, name, x, y):
            self.name = name
            self.max_health = 10
            self.health = 10
            self.max_hunger = 10
            self.hunger = 10
            self.exp = 0
            self.level = 1

            self.attack = 2
            self.armor = 2
            self.cash = 0
            
            self.alpha = 0
            self.x = 0
            self.y = 0
            self.direction = "down"
            self.stat = "idle"
            self.busy = 0
        def tick(self):
            if self.busy > 0:
                self.busy -= 1
            if self.busy < 1:
                self.stat = "idle"
            


screen level(g):
    default scale = 2.0
    if not g.player.alpha:
        timer .4 action Function(g.show_player)
    hbox:
        align .5,.0 spacing 10
        bar value ScreenVariableValue("scale", 3.0, offset=1.0) xysize 500,40
        button:
            ysize 40 xpadding 10 background "#099"
            text "reset" align .5,.5
            action SetScreenVariable("scale", 2.0)
    fixed:
        fit_first True align(.5, .0) yoffset 64
        at zoom(scale)
        frame:
            background None padding(0,0)
            vbox:
                for ii in g.map:
                    hbox:
                        for i in ii:
                            if i[0] == "-1":
                                frame:
                                    background None xysize(g.size,g.size)
                            else:
                                frame:
                                    background g.set[int(i[0])]
                                    xysize(g.size,g.size)
                                    if len(i[1]):
                                        text i[0] size 20 align .5,.5
                                # add i.image
        frame:
            xysize(g.size, g.size) background None at player_move(g.player.x*g.size, g.player.y*g.size)
            add "{} {} {}".format(g.player.name, g.player.direction, g.player.stat) align(.5,.5) yoffset -8 at alpha(g.player.alpha)

    if g.player.busy > 0:
        timer .1 repeat True action Function(g.player.tick)
        key "w" action NullAction()
        key "a" action NullAction()
        key "s" action NullAction()
        key "d" action NullAction()
    else:
        key "w" action Function(g.move, "up")
        key "a" action Function(g.move, "left")
        key "s" action Function(g.move, "down")
        key "d" action Function(g.move, "right")

    add "gui_mockup"
    text "{} - {},{}".format(g.name, g.player.x, g.player.y)
transform player_move(x, y):
    linear .4 xpos x ypos y


# --------------------------------


define you_sheet = "rpg/01.png"
image You down idle = Crop((32, 0, 32, 32), you_sheet)
image You down walk:
    Crop((0, 0, 32, 32), you_sheet)
    pause .1
    Crop((32, 0, 32, 32), you_sheet)
    pause .1
    Crop((64, 0, 32, 32), you_sheet)
    pause .1
    Crop((32, 0, 32, 32), you_sheet)
    pause .1
    repeat

image You up idle = Crop((32, 96, 32, 32), you_sheet)
image You up walk:
    Crop((0, 96, 32, 32), you_sheet)
    pause .1
    Crop((32, 96, 32, 32), you_sheet)
    pause .1
    Crop((64, 96, 32, 32), you_sheet)
    pause .1
    Crop((32, 96, 32, 32), you_sheet)
    pause .1
    repeat

image You left idle = Crop((32, 32, 32, 32), you_sheet)
image You left walk:
    Crop((0, 32, 32, 32), you_sheet)
    pause .1
    Crop((32, 32, 32, 32), you_sheet)
    pause .1
    Crop((64, 32, 32, 32), you_sheet)
    pause .1
    Crop((32, 32, 32, 32), you_sheet)
    pause .1
    repeat

image You right idle = Crop((32, 64, 32, 32), you_sheet)
image You right walk:
    Crop((0, 64, 32, 32), you_sheet)
    pause .1
    Crop((32, 64, 32, 32), you_sheet)
    pause .1
    Crop((64, 64, 32, 32), you_sheet)
    pause .1
    Crop((32, 64, 32, 32), you_sheet)
    pause .1
    repeat



default player = actor(
    "You",
    0,0,

)
default level_1 = level_class(
    _("Level 1"),
    32,
    ["labyrinth ground", "rpg/level_1.csv"],
    None,
    player = player,
    entrances = [[15,4]],
    exits = [[15, 3, "the_well", 1]]
)
default the_well = level_class(
    _("The well"),
    32,
    ["labyrinth ground", "rpg/the_well.csv"],
    None,
    player = player,
    entrances = [[3,1], [24,8]],
    exits = [[3, 0, "level_2", 0], [24, 9, "level_1", 0]]
)
default level_2 = level_class(
    _("Level 2"),
    32,
    ["labyrinth ground", "rpg/level_2.csv"],
    None,
    player = player,
    entrances = [[2,6], [25,2]],
    exits = [[2, 7, "the_well", 0], [25, 1, "level_3", 0]]
)
default level_3 = level_class(
    _("Level 3"),
    32,
    ["labyrinth ground", "rpg/level_3.csv"],
    None,
    player = player,
    entrances = [[3,9], [25,2]],
    exits = [[3, 10, "level_2", 1], [25, 1, "level_3", 0]]
)

label level_1:
    $ the_well.enter(0)
    call screen level(the_well)










